//
// Copyright (C) 1991 Texas Instruments Incorporated.
//
// Permission is granted to any individual or institution to use, copy, modify,
// and distribute this software, provided that this complete copyright and
// permission notice is maintained, intact, in all copies and supporting
// documentation.
//
// Texas Instruments Incorporated provides this software "as is" without
// express or implied warranty.
//
// Created: MJF 07/05/89 -- Initial design and implementation.
// Updated: MJF 02/22/90 -- New constructor for initializing group name.

// An overview of the structure of the Exception class, the Excp_Handler class
// and the exception mechanism for creating, raising and handling an exception
// can be found in the Exception.h header file.

#include <cool/Exception.h>	// include the Exception header file.
#include <cool/Generic.h>	// include the Generic header file.

// ************************************************************************
// Constructor for Exception class
// ************************************************************************

// Exception(Excp_Type) - an Exception constructor which initializes the
//                        group names with the specified exception type.
//
// Input:   An exception type.
// Output:  None.

Exception::Exception(Excp_Type etype) {
  this->excp_handled = FALSE;
  this->msg_prefix = this->format_msg = NULL;
  this->set_group_names(etype);
}

