//
// Copyright (C) 1991 Texas Instruments Incorporated.
//
// Permission is granted to any individual or institution to use, copy, modify,
// and distribute this software, provided that this complete copyright and
// permission notice is maintained, intact, in all copies and supporting
// documentation.
//
// Texas Instruments Incorporated provides this software "as is" without
// express or implied warranty.
//
// Created: MJF 06/15/89 -- Initial design and implementation.
// Updated: MJF 02/22/90 -- Split into separate file.

// An overview of the structure of the IGNORE_ERRS macro and the Jump_Handler
// class can be found in the Ignore_Errs.h header file.

#include <cool/Exception.h>	// include the Exception header file.
#include <cool/Generic.h>	// include the Generic header file.
#include <cool/Ignore_Errs.h>   // include the Ignore_Errs header file.

// *********************************************************************
// Jump_Handler function used by IGNORE_ERRORS macro
// *********************************************************************

//  ignore_errors_handler  -- a handler function used to ignore error raised
//                            via RAISE or STOP.
//  INPUT:   Pointer to an Exception object.
//  OUTPUT:  None.

void ignore_errors_handler(Exception* excp, Excp_Handler* eh) {
   Jump_Handler* jh = (Jump_Handler*) eh;
   jh->raised_excp = excp;
   if (jh->env)		  // this will return to where setjmp()
     longjmp(jh->env,1);  // was called in IGNORE_ERRORS
}
