//
// Copyright (C) 1991 Texas Instruments Incorporated.
//
// Permission is granted to any individual or institution to use, copy, modify,
// and distribute this software, provided that this complete copyright and
// permission notice is maintained, intact, in all copies and supporting
// documentation.
//
// Texas Instruments Incorporated provides this software "as is" without
// express or implied warranty.
//
// Created: MJF 07/05/89 -- Initial design and implementation.
// Updated: MJF 02/22/90 -- Split into separate file.

// An overview of the structure of the Exception class, the Excp_Handler class
// and the exception mechanism for creating, raising and handling an exception
// can be found in the Exception.h header file.

#include <cool/Exception.h>	// include the Exception header file.
#include <cool/Generic.h>	// include the Generic header file.

// ******************************************************
// Member function for Verify_Error class
// ******************************************************

// void Verify_Error::report(ostream&) -- reports the Verify_Error message 
//                                        on specified output stream.
//
// INPUT:   Output stream.
// OUTPUT:  None.

void Verify_Error::report(ostream& os) CONST {
  os << this->message_prefix() << ": ";
  os << form(this->format_msg, this->test) << "\n";
}
