//
// Copyright (C) 1991 Texas Instruments Incorporated.
//
// Permission is granted to any individual or institution to use, copy, modify,
// and distribute this software, provided that this complete copyright and
// permission notice is maintained, intact, in all copies and supporting
// documentation.
//
// Texas Instruments Incorporated provides this software "as is" without
// express or implied warranty.
//
// Created: LGO 05/22/89 -- Initial design and implementation
// Updated: MBN 09/16/89 -- Added conditional exception handling
//

#include <cool/Generic.h>
#include <cool/Properties.h>
#include <cool/Symbol.h>

// The following is required because symbol
// is declared before all of generic is included:
IMPLEMENT_GENERIC(Symbol);


// Symbol() -- Constructor only for use to create an array of constant symbols
// Input:      None
// Output:     None

Symbol::Symbol() {
  pname = "";					// Initialize name string
  val = NULL;					// Set value pointer to NULL
  proplist = NULL;				// Set plist to NULL
}


// ~Symbol -- Destructor (not inline because it's virtual)
// Input:     None
// Output:    None

Symbol::~Symbol () {}
