//
// Copyright (C) 1991 Texas Instruments Incorporated.
//
// Permission is granted to any individual or institution to use, copy, modify,
// and distribute this software, provided that this complete copyright and
// permission notice is maintained, intact, in all copies and supporting
// documentation.
//
// Texas Instruments Incorporated provides this software "as is" without
// express or implied warranty.
//
// Created: MBN 08/31/89 -- Initial design and implementation
// Updated: MJF 03/12/90 -- Added group names to RAISE
//

#include <cool/Base_Vector.h>			// Include the class header
#include <cool/Generic.h>			// Include the class header


// resize_error -- Raise exception for Vector<Type>::resize()
// Input:          Type string, size argument
// Output:         None

void Vector::resize_error (const char* Type, const long n) CONST {
  RAISE (Error, SYM(Vector), SYM(Negative_Size),
	 "Vector<%s>::resize(): Negative resize %d", Type, n);
}

// static_error -- Raise exception for Vector<Type>::resize()
// Input:          Type string, size argument
// Output:         None

void Vector::static_error (const char* Type) CONST {
  RAISE (Error, SYM(Vector), SYM(Static_Size),
	 "Vector<%s>::resize(): Static-size vector", Type);
}
