//
// Copyright (C) 1991 Texas Instruments Incorporated.
//
// Permission is granted to any individual or institution to use, copy, modify,
// and distribute this software, provided that this complete copyright and
// permission notice is maintained, intact, in all copies and supporting
// documentation.
//
// Texas Instruments Incorporated provides this software "as is" without
// express or implied warranty.
//
// This file must be  compiled and linked with every  application utilizing the
// COOL library. The sample makefile shows the procedure for compilation order.
// It is important that this be the last file  compiled before the link process
// begins. The  constant  symbols in the  SYM package  and ERR_MSG  package are
// initialized by invoking the implement macros defined in <COOL/defpackage.h>
//

#include <cool/String.h>
#include <cool/Package.h>
#include <cool/Properties.h>

// This is done in symbols.C
// implement_symbol_package (SYM, "sym_package.p")
// implement_text_package (ERR_MSG, "err_package.p")

// The next three lines are added to insure that the text and symbol packages
// manipulated by examples 11.11a.C, 11.11b.C, and 11.13.C are allocated and
// initialized, respectively
     
// implement_text_package (MY_TEXT, "my_text.p")
// implement_text_package (MY_TEXT, "my_text2.p")
implement_symbol_package (MY_SYM, "my_sym.p")

